#include <windows.h>
#include <olectl.h>

LPPICTURE			gpPicture;
HWND				hWnd;
HDC					hDC;
long				hmWidth,hmHeight;
int					SrcX,SrcY,dl,dt,dx,dy,sx,sy;

LRESULT CALLBACK MainWndProc(HWND, UINT,WPARAM, LPARAM);
void LoadPictureFile(char* point);

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{

	MSG			msg;
	WNDCLASS	wndclass;
	char		*p,*q;

	wndclass.style = 0;
	wndclass.cbClsExtra = 0;
	wndclass.cbWndExtra = 0;
	wndclass.hCursor = LoadCursor(NULL, IDC_ARROW);
	wndclass.lpszMenuName =  NULL;
    hInstance=GetModuleHandle(NULL);
	wndclass.hInstance = hInstance;
	wndclass.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(100));
	wndclass.lpfnWndProc = MainWndProc;
	wndclass.hbrBackground = (HBRUSH)(GetStockObject (BLACK_BRUSH));
	wndclass.lpszClassName = "MyWindowClass";
	RegisterClass (&wndclass);
	dl=(GetSystemMetrics(SM_CXFULLSCREEN)-400)/2;
	dt=(GetSystemMetrics(SM_CYFULLSCREEN)-300)/2;
	dx=400;
	dy=300;
	hWnd = CreateWindow ("MyWindowClass","LoadPic",
						 WS_MAXIMIZEBOX|WS_MINIMIZEBOX|WS_SYSMENU|WS_SIZEBOX,
						 dl,dt,dx,dy,NULL,NULL,hInstance,NULL);
	hDC = GetDC(hWnd);
	DragAcceptFiles(hWnd,TRUE);
	p=GetCommandLine();
	if(*p=='"')
	{
		do
		{
			p++;
		}
		while(*p!='"');
	}
    do
	{
		p++;
	}
	while((*p!='\0')&&(*p!=' '));
	p--;
	do
	{
		p++;
	}
	while(*p==' ');
	if(*p=='"')
	{
		q=p;
		p++;
		*q=' ';
		do
		{
			q++;
		}
		while(*q!='"');
		*q='\0';
	}
	if(*p!='\0')
	{
		LoadPictureFile(p);
	}
	ShowWindow(hWnd, SW_SHOWNORMAL);
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		DispatchMessage(&msg);
	}
	return 0;
}

void LoadPictureFile(char* point)
{
	char		szPath[255];
	OLECHAR		wszPath[255];
	int			i,j;
	
	if (gpPicture)
	{
		gpPicture->Release();
	}
	i=0;
	j=0;
	do
	{
		szPath[j]=point[i];
		if(szPath[j]=='\\')
		{
			j++;
			szPath[j]='\\';
		}
		i++;
		j++;
	}while(point[i-1]!='\0');
	MultiByteToWideChar(CP_ACP, 0, szPath, -1, wszPath, 255);  
	OleLoadPicturePath(wszPath, 0, 0, 0, IID_IPicture, (LPVOID *)&gpPicture);
	gpPicture->get_Width(&hmWidth);
	gpPicture->get_Height(&hmHeight);
	SrcX=hmWidth*GetDeviceCaps(hDC, LOGPIXELSX)/2540;
	SrcY=hmHeight*GetDeviceCaps(hDC, LOGPIXELSY)/2540;
	sx=SrcX;
	sy=SrcY;
	dx=GetSystemMetrics(SM_CXFULLSCREEN);
	dy=GetSystemMetrics(SM_CYFULLSCREEN);
	while((sx>dx)&&(sy>dy))
	{
		sx=sx>>1;
		sy=sy>>1;
	}
	dl=-4;
	dt=-4;
	if(dx>sx)
	{
		dl=(dx-sx-8)>>1;
		dx=	sx;
	}
	if(dy>sy)
	{
		dt=(dy-sy)>>1;
		dy=sy;
	}
	dx=dx+8;
	dy=dy+27;
	EndDeferWindowPos(DeferWindowPos(BeginDeferWindowPos(1),hWnd,HWND_TOP,dl,dt,dx,dy,SWP_NOZORDER));
	InvalidateRect(hWnd,NULL,0);
}

LRESULT CALLBACK MainWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT		ps;
	OPENFILENAME	ofn;
    char			szFileName[255];
	
	switch (message) 
	{
		case WM_RBUTTONUP:
			szFileName[0]='\0';
			ofn.lStructSize=sizeof(OPENFILENAME);
			ofn.hwndOwner=hWnd;
			ofn.hInstance=0;
			ofn.lpstrFilter="JPG Files (*.jpg)\0*.jpg\0";
			ofn.lpstrCustomFilter=0;
			ofn.nMaxCustFilter=0;
			ofn.nFilterIndex=0;
			ofn.lpstrFile=szFileName;
			ofn.nMaxFile=MAX_PATH;	
			ofn.lpstrFileTitle=0;
			ofn.nMaxFileTitle=MAX_PATH;			
			ofn.lpstrInitialDir=0;
			ofn.lpstrTitle=0;
			ofn.Flags=OFN_HIDEREADONLY|OFN_PATHMUSTEXIST;
			ofn.nFileOffset=0;
			ofn.nFileExtension=0;
			ofn.lpstrDefExt=NULL;
			ofn.lCustData=0;
			ofn.lpfnHook=0;
			ofn.lpTemplateName=0;
			if (!GetOpenFileName(&ofn)) 
			{
				break;
			}
		case WM_DROPFILES:
    		if(message==WM_DROPFILES)
			{
				DragQueryFile((HDROP)wParam, 0, szFileName, 255);
			}
			LoadPictureFile(szFileName);
			break;
		case WM_GETMINMAXINFO:
			((LPMINMAXINFO)lParam)->ptMaxPosition.x=dl;
			((LPMINMAXINFO)lParam)->ptMaxPosition.y=dt;
			((LPMINMAXINFO)lParam)->ptMaxSize.x=dx;
			((LPMINMAXINFO)lParam)->ptMaxSize.y=dy;
			((LPMINMAXINFO)lParam)->ptMaxTrackSize.x=dx;
			((LPMINMAXINFO)lParam)->ptMaxTrackSize.y=dy;
			break;
		case WM_PAINT:
			BeginPaint(hWnd, &ps);
			if (gpPicture)
			{
				gpPicture->Render(hDC, 0, 0, sx, sy, 0, hmHeight, hmWidth, -hmHeight, NULL);
			}
			EndPaint(hWnd, &ps);
			break;
		case WM_DESTROY:
			ExitProcess(0);	
			break;
		default:
			return DefWindowProc (hWnd, message, wParam, lParam);
   }
   return 0;
}
